Index: branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl
===================================================================
--- branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/vtkisosurfaceviewer.tcl	(revision 4504)
@@ -141,4 +141,6 @@
     private variable _contourList
     private variable _currentLimits ""
+    private variable _widget
+
     common _downloadPopup;              # download options from popup
     private common _hardcopy
@@ -242,5 +244,5 @@
         -cutplaneedges                  0
         -cutplanelighting               1
-        -cutplaneopacity                100
+        -cutplaneopacity                1.0
         -cutplanepreinterp              1
         -cutplanesvisible               0
@@ -250,5 +252,5 @@
         -isosurfaceedges                0
         -isosurfacelighting             1
-        -isosurfaceopacity              60
+        -isosurfaceopacity              0.6
         -isosurfacevisible              1
         -isosurfacewireframe            0
@@ -269,5 +271,10 @@
         -colormap                0
         -isosurfaceopacity       0
+        -cutplaneopacity         0
         -numcontours             0
+    }
+    array set _widget {
+        -isosurfaceopacity       0
+        -cutplaneopacity         0
     }
 
@@ -483,5 +490,5 @@
     GenerateContourList
     SendCmd [list contour3d contourlist $_contourList(values)]
-    #SendCmd [list camera reset]
+    SendCmd [list camera reset]
     DrawLegend
     set _contourList(updatePending) 0
@@ -970,5 +977,4 @@
     # generates a new call to Rebuild).   
     StartBufferingCommands
-
     if { $_reset } {
         set _width $w
@@ -991,7 +997,7 @@
         InitSettings -xgrid -ygrid -zgrid -axismode \
             -axesvisible -axislabelsvisible 
-        foreach axis { x y z } {
-	    SendCmd "axis lformat $axis %g"
-	}
+        SendCmd "axis lformat all %g"
+        # Too many major ticks, so turn off minor ticks
+        SendCmd "axis minticks all 0"
         StopBufferingCommands
         SendCmd "imgflush"
@@ -1101,5 +1107,4 @@
                 set label [string toupper $axis]
 	    }
-	    # May be a space in the axis label.
 	    SendCmd [list axis name $axis $label]
         }
@@ -1413,7 +1418,6 @@
         }
         "-cutplaneopacity" {
-            set val $_settings($what)
-            set sval [expr { 0.01 * double($val) }]
-            SendCmd "cutplane opacity $sval"
+            set _settings($what) [$_widget(-cutplaneopacity) * 0.01]
+            SendCmd "cutplane opacity $_settings($what)"
         }
         "-cutplanepreinterp" {
@@ -1509,7 +1513,6 @@
         }
         "-isosurfaceopacity" {
-            set val $_settings($what)
-            set sval [expr { 0.01 * double($val) }]
-	    SendCmd "contour3d opacity $sval"
+            set _settings($what) [$_widget(-isosurfaceopacity) * 0.01]
+	    SendCmd "contour3d opacity $_settings($what)"
         }
         "-field" {
@@ -1539,4 +1542,5 @@
             SendCmd "contour3d colormode $_colorMode $_curFldName"
             SendCmd "camera reset"
+            UpdateContourList
             DrawLegend
         }
@@ -1714,8 +1718,9 @@
     label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-isosurfaceopacity)] \
+        -variable [itcl::scope _widget(-isosurfaceopacity)] \
         -width 10 \
         -showvalue off \
         -command [itcl::code $this AdjustSetting -isosurfaceopacity]
+    $inner.opacity set [expr $_settings(-isosurfaceeopacity) * 100.0]
 
     itk_component add field_l {
@@ -1734,6 +1739,6 @@
         Rappture::Combobox $inner.colormap -width 10 -editable 0
     }
-
     $inner.colormap choices insert end [GetColormapList]
+
     $itk_component(colormap) value "BCGYR"
     bind $inner.colormap <<Value>> \
@@ -1927,9 +1932,9 @@
     label $inner.opacity_l -text "Opacity" -font "Arial 9"
     ::scale $inner.opacity -from 0 -to 100 -orient horizontal \
-        -variable [itcl::scope _settings(-cutplaneopacity)] \
+        -variable [itcl::scope _widget(-cutplaneopacity)] \
         -width 10 \
         -showvalue off \
         -command [itcl::code $this AdjustSetting -cutplaneopacity]
-    $inner.opacity set $_settings(-cutplaneopacity)
+    $inner.opacity set [expr $_settings(-cutplaneopacity) * 100.0]
 
     # X-value slicer...
@@ -2150,25 +2155,25 @@
     set tag $dataobj-$comp
     array set style {
-        -color BCGYR
-        -cutplanesvisible 0 
-        -edgecolor black
-        -edges 0
-        -isosurfacevisible 1
-        -levels 10
-        -lighting 1
-        -linewidth 1.0
-        -opacity 0.6
-        -outline 0
-        -wireframe 0
-        -xcutplaneposition 50
-        -xcutplanevisible 1
-        -ycutplaneposition 50
-        -ycutplanevisible 1
-        -zcutplaneposition 50
-        -zcutplanevisible 1
+        -color                  BCGYR
+        -cutplanesvisible       0 
+        -edgecolor              black
+        -edges                  0
+        -isosurfaceopacity      0.6
+        -isosurfacevisible      1
+        -levels                 10
+        -lighting               1
+        -linewidth              1.0
+        -outline                0
+        -wireframe              0
+        -xcutplaneposition      50
+        -xcutplanevisible       1
+        -ycutplaneposition      50
+        -ycutplanevisible       1
+        -zcutplaneposition      50
+        -zcutplanevisible       1
     }
     array set style [$dataobj style $comp]
     if { $dataobj != $_first || $style(-levels) == 1 } {
-        set style(-opacity) 1
+        set style(-isosurfaceopacity) 1.0
     }
 
@@ -2183,5 +2188,5 @@
 
     if { $_changed(-isosurfaceopacity) } {
-        set style(-opacity) [expr $_settings(-isosurfaceopacity) * 0.01]
+        set style(-isosurfaceopacity) $_settings(-isosurfaceopacity)
     }
     if { $_changed(-numcontours) } {
@@ -2196,7 +2201,11 @@
     }
     if { $_contourList(numLevels) != $style(-levels) } {
-        set _settings(-numcontours) $style(-levels)
-        $itk_component(numcontours) value $style(-levels)
-        set _contourList(numLevels) $style(-levels)
+        if { [llength $style(-levels)] > 1 } {
+            set _contourList(reqValues) [lsort -real $style(-levels)]
+        } else {
+            set _settings(-numcontours) $style(-levels)
+            $itk_component(numcontours) value $style(-levels)
+            set _contourList(numLevels) $style(-levels)
+        }
         EventuallyChangeContourLevels 
     }
@@ -2228,6 +2237,6 @@
     SendCmd "contour3d linecolor [Color2RGB $style(-edgecolor)] $tag"
     SendCmd "contour3d linewidth $style(-linewidth) $tag"
-    SendCmd "contour3d opacity $style(-opacity) $tag"
-    set _settings(-isosurfaceopacity) [expr $style(-opacity) * 100.0]
+    SendCmd "contour3d opacity $style(-isosurfaceopacity) $tag"
+    set _settings(-isosurfaceopacity) $style(-isosurfaceopacity)
     SetCurrentColormap $style(-color) 
     SendCmd "contour3d wireframe $style(-wireframe) $tag"
@@ -2593,15 +2602,21 @@
 itcl::body Rappture::VtkIsosurfaceViewer::GenerateContourList {} { 
     if { ![info exists _limits($_curFldName)] } {
+        puts stderr "no _curFldName"
         return ""
     }
     if { $_contourList(numLevels) < 1 } {
+        puts stderr "numLevels < 1"
         return ""
     }
-    foreach { vmin vmax } $_limits($_curFldName) break
-    set v [blt::vector create \#auto]
-    $v seq $vmin $vmax [expr $_contourList(numLevels)+2]
-    $v delete end 0
-    set values [$v range 0 end]
-    blt::vector destroy $v
+    if { [llength $_contourList(reqValues)] > 1 } {
+        set values $_contourList(reqValues)
+    } else {
+        foreach { vmin vmax } $_limits($_curFldName) break
+        set v [blt::vector create \#auto]
+        $v seq $vmin $vmax [expr $_contourList(numLevels)+2]
+        $v delete end 0
+        set values [$v range 0 end]
+        blt::vector destroy $v
+    }
     set _contourList(values) $values
 }
